# Quorum Entropy Ceremony

This is a ceremony for generating entropy which is used to derive Quorum PGP keys, load them into smart cards and shard entropy to them. 

## Requirements

{{ #include ../../operator-requirements.md:requirements }}

* [SD Card Booster Pack](../provisioner/provision-sd-card.md)

* `N` Smart Cards in the chosen `M of N` quorum

* [High Visibility Storage](TODO): plastic container or bag that's used to keep items while not in use in a visible location like the middle of a desk.

## Procedure 

1. Enter the designated location with required personnel and equipment

1. Lock access to the location - there should be no inflow or outflow of people during the ceremony

1. Retrieve Air-Gapped Bundle and polaroid tamper evidence from locked storage

{{ #include ../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-unsealing}}

1. Place all materials except for the laptop into High Visibility Storage

1. Retrieve AirgapOS SD card from High Visibility Storage and plug it into air-gapped laptop 

1. Turn on the machine

1. Once booted, remove the AirgapOS SD card and place it into High Visibility Storage

1. Run the relevant keyfork wizard to perform the ceremony:

    * Replace the following values: <M>, <N>, <number_of_smart_cards_per_operator>, <pgp_cert_id>


    * `keyfork wizard generate-shard-secret --threshold <M> --max <N> --keys-per-shard=<number_of_smartcards_per_operator> --output shardfile.asc --cert-output keyring.asc --derive-openpgp-cert encryption_cert.asc,userid=<pgp_cert_id>` TODO: NOT IMPLEMENTED


1. Unseal an SD card pack

{{ #include ../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-unsealing}}

1. Place all unsealed SD cards into High Visibility Storage

1. Plug in SD cards one at a time and use following steps to back up ceremony artifacts

    1. {{ #include ../../../../component-documents/finding-device-name.md:content }}

    1. Back up the root OpenPGP certificate

        * `cp encryption_cert.asc /media/<device_name>/`

    1. Back up the `shardfile.asc`     

        * `cp shardfile.asc /media/<device_name>/` 

    1. Back up the `keyring.asc`

        * `cp keyring.asc /media/<device_name>/`

    1. Unplug the SD card and place it in High Visibility Storage

    1. Label the SD card "Shardfile [date]"

1. Upload the newly generated artifacts into the `vaults` repository

1. Gather all the original items that were in the air-gapped bundle:

    * Air-gapped computer

    * AirgapOS SD card

{{ #include ../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-sealing}}
